<template>
    <div  class=" entreprise-item col-sm-12 col-md-4   col-lg-3">
<!-- Card Regular -->
<div class="card card-cascade">

  <!-- Card image -->
  <div class="card-actions">
        <button v-if="false" type="button" title="Voir l'entreprise'" class="btn" @click="seeEnterprise">
            <i class="fas  fa-eye"></i>
    </button>
    <button type="button" title="Modifier l'entreprise" class="btn"   @click="updateEnterprise">
            <i class="fas  fa-edit"></i> 
    </button>
    <button type="button" title="Supprimer l'entreprise'" class="btn" @click="deleteEnterprise">
            <i class="fas  fa-trash"></i>
    </button>
  </div>
  <div class="view view-cascade overlay">
    <img :src=" entity.pays.hasFlag ? '/storage/flags/'+entity.pays.flagPath : '/storage/flags/unknown.png'"  :title="entity.pays.libelle"  alt="" class="src nationalite-flag">

    <!-- <img class="card-img-top" :src="entity.hasLogo ? 'storage/featured/'+entity.logo : '/img/entreprise_defaut_card.jpg' " alt="Card image cap"> -->
    <div class="card-img-top align-items-md-center card-img-top d-flex flex-column">
          <div class="logo-img">
              <img class="card-img-log" :src="entity.hasLogo ? 'storage/featured/'+entity.logo : '/img/industry-solid.png'" alt="Card image cap">
          </div>
        <div class="logo-facop">
              <!-- <img height="50" class="card-img-log" :src="'/img/logo_prepagabon.png' " alt="Card image cap"> -->
          </div>
    </div>
    <!-- <router-link  :to="'/entreprises/'+entity.id"> -->
      <a href="javascript:void(0)" @click.prevent="seeEnterprise">
        <div class="mask rgba-white-slight waves-effect waves-light"></div>
      </a>
    <!-- </router-link> -->
  </div>

  <!-- Card content -->
  <div class="card-body card-body-cascade text-center">

    <!-- Title -->
    <h4 class="card-title text-uppercase truncate"><strong>{{ entity.nom_commercial}}</strong></h4>
    <!-- Subtitle -->
    <h6 class="font-weight-bold indigo-text py-2 truncate">{{ entity.secteur.libelle}}</h6>
    <!-- Text -->
    <p class="card-text">
               <span v-if="entity.contact"> <i class="fas fa-phone-square mr-1"></i> {{entity.contact ? entity.contact.phone1 :   "" }}</span>
               <span v-if="entity.contact"> <i class="fas fa-phone-square mr-1 ml-1"></i> {{entity.contact ? entity.contact.phone1 :   "" }}</span>
    </p>

    <!-- Facebook -->
    <a type="button" class="btn-floating btn-small btn-fb"><i class="fab fa-facebook-f"></i></a>
    <!-- Twitter -->
    <a type="button" class="btn-floating btn-small btn-tw"><i class="fab fa-twitter"></i></a>
    <!-- Google + -->
    <a type="button" class="btn-floating btn-small btn-dribbble"><i class="fab fa-linkedin"></i></a>

  </div> 
  <div class="card-footer text-muted text-center">
            <p class="mb-0 truncate">
                <a v-if="entity.responsable" href="javascript:void(0)" @click.prevent="seeMember"><i class="fas fa-user"></i> <strong>{{  entity.responsable.fullNameWithTitel }}</strong></a>
                <a v-else href="javascript:void(0)"><i class="fas fa-user"></i> <strong>Inconnu</strong></a>

            </p>
           <p class="mb-1"><i class="far fa-calendar-alt"></i> <strong>{{ entity.created_at | toDate }}</strong></p>

  </div>

</div>
<!-- Card Regular -->
      </div >
</template>
<script>
    export default {
        props: ['entity','isSet'],       
         data() {
            return{
                vehicule_est_connu:false,
                vehicule:{
                    libelle: "Wills",
                    marque_id: 5,
                    modele_id: 51,
                    type_vehicule_id: 1,
                    type_permis_id: null,
                    nbr_place: 5,
                    nbr_porte: 5,
                    couleur: "Rouge",
                    image_mise_en_avant: "22-5e6296894e7be.jpeg",
                    tarif: 50000,
                    kilometrage: 23554,
                    plaque_immatriculation: "AZSE-RTDFD-ddd",
                    nr_chassis: "ERDF-ERFFF-FR",
                    date_mise_en_circulation: "2016-02-05",
                    annee_mise_en_circulation: "0000-02-05 00:00:00",
                    consommation_au_100_km: 5.5,
                    type_motorisation_id: 13,
                    boite_vitesse: "automatique",
                    volume_coffre: 100,
                    volume_reservoir: 60,
                    largeur: 2.4,
                    longueur: null,
                    poids: 1290,
                    hauteur: null,
                    created_at: "2020-03-06 18:29:29",
                    updated_at: "2020-03-06 18:29:29",
                    path: "/storage/images/",
                    marque : {},
                    modele : {},
                    marque: {},
                    title: "",
                    modele: {},
                    type_motorisation: {},
                    type_vehicule: {}
                }
            }
            
        },
        mounted() {
            this.vehicule = this.entity
            this.vehicule_est_connu = this.isSet != null ? this.isSet : this.vehicule_est_connu

        },
        computed:
        {
            joursRestant()
            {
                 var jours = 0
                if(this.location.date_fin_prev=="") return jours
                if(this.dateDepassee_ || this.dateEnAttente )
                {
                    jours = 0
                }
                else
                {
                    var end = moment(this.location.date_fin_prev);
                    jours = this.entity.nbr_jour - end.diff(moment(), 'days')
                    console.log(this.entity.nbr_jour,jours)
                }
                return jours
            },
            
             dateDepassee_()
            {
                if(this.location.date_fin_prev=="") return false
                 
                var now = moment();
                var end = moment(this.location.date_fin_prev);
                return now.isAfter(end);
            },
            dateEnAttente()
            {
                if(this.location.date_dbt=="") return false
                 
                var now = moment();
                var start = moment(this.location.date_dbt);
                return now.isBefore(start);
            },
            enCours()
            {
             if(this.location.date_dbt=="") return false
                 
                var now = moment();
                var start = moment(this.location.date_dbt);
                return now.after(start) && this.dateDepassee_==false;
            },
            progression()
            {
                let percent  = 0
                 if(this.dateDepassee_ && this.joursRestant == 0)
                 {
                     percent = 100
                 }
              
                return percent
            },

        },
        methods:
        {

            updateEnterprise()
            {
                 window.event.$emit('update-enterprise-event',this.entity)

            },
            seeMember()
            {
                 window.event.$emit('see-member-event',{entity:this.entity.responsable,key:1})

            },
            seeEnterprise()
            {
                 window.event.$emit('see-enterprise-event',this.entity)

            },
            deleteEnterprise()
            {
                  //On demande la confirmation de la suppression
                    alertConfirm("Voulez-vous supprimer cette entreprise ?","Suppréssion d'une entreprise")
                    .then(result => {
                        //On réinitialise le chargement
                        this.isLoading = true
                        if(result)
                        {
                               this.$store.dispatch('enterprises/removeEnterprise',this.entity).then((response) =>
                                {
                                        this.isLoading = false
                                        flash("<span>Supprimé <strong>avec succès</strong></span>",'success')
                                },
                                (error) => 
                                {
                                    this.isLoading = false
                                })
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });
            },
            
            prolongerEvent(location)
            {
              location.vehicule.marque = this.vehicule.marque
              window.event.$emit('prolongement-event',location)
            },
            removeEvent(vehicule)
            {
              this.$emit('suppression-event',vehicule)
            },
            rentEvent(vehicule)
            {
              this.$emit('location-event',vehicule)
            },
            nowIsOverdue(end)
            {
                var now = moment();
                var end = moment(end);
                return now.isAfter(end);
            },
        }
    }
</script>
<style lang="scss" scoped>

.logo-img .card-img-log{
    width: 236px;
    height: 190px;
    object-fit: cover;
}

.card-img[data-v-7304bc64], .card-img-top[data-v-7304bc64], .card-img-bottom[data-v-7304bc64]{
    background-color: #fff;
}

.fa-edit{
    color:green;
}

.fa-trash{
    color:red;
}

a:not([href]):not([tabindex]), a:not([href]):not([tabindex]):focus, a:not([href]):not([tabindex]):hover {
    color: inherit;
    text-decoration: none;
}

button:not(:disabled), [type="button"]:not(:disabled), [type="reset"]:not(:disabled), [type="submit"]:not(:disabled) {
    cursor: pointer;
}
button, html [type="button"], [type="reset"], [type="submit"] {
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
}
a.waves-effect, a.waves-light {
    display: inline-block;
}
a:not([href]) {
    color: inherit;
    text-decoration: none;
}
.btn-fb {
    color: #fff;
    background-color: #3b5998 !important;
}
.btn-floating {
    position: relative;
    z-index: 1;
    display: inline-block;
    padding: 0;
    margin: 10px;
    overflow: hidden;
    vertical-align: middle;
    cursor: pointer;
    border-radius: 50%;
    -webkit-box-shadow: 0 5px 11px 0 rgba(0,0,0,0.18), 0 4px 15px 0 rgba(0,0,0,0.15);
    box-shadow: 0 5px 11px 0 rgba(0,0,0,0.18), 0 4px 15px 0 rgba(0,0,0,0.15);
    -webkit-transition: all .2s ease-in-out;
    transition: all .2s ease-in-out;
    width: 30px;
    height: 30px;
}
.waves-effect {
    position: relative;
    overflow: hidden;
    cursor: pointer;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    -webkit-tap-highlight-color: transparent;
}
.btn-floating i {
    display: inline-block;
    width: inherit;
    color: #fff;
    text-align: center;
}

.btn-floating i {
    font-size: 1.1rem;
    line-height: 30px;
}
.fab {
    font-family: "Font Awesome 5 Brands";
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxx
.indigo-text {
    color: #3f51b5 !important;
}

.font-weight-bold {
    font-weight: 700 !important;
}
.text-center {
    text-align: center !important;
}
.btn-tw {
    color: #fff;
    background-color: #55acee !important;
}
.btn-dribbble {
    color: #fff;
    background-color: #ec4a89 !important;
}
.text-muted {
    color: #6c757d !important;
}
.text-center {
    text-align: center !important;
}
.card-img, .card-img-top, .card-img-bottom {
    -ms-flex-negative: 0;
    flex-shrink: 0;
    width: 100%;
}
.entreprise-item .card {
    font-weight: 400;
    border: 0;
    -webkit-box-shadow: 0 2px 5px 0 rgba(0,0,0,0.16), 0 2px 10px 0 rgba(0,0,0,0.12);
    box-shadow: 0 2px 5px 0 rgba(0,0,0,0.16), 0 2px 10px 0 rgba(0,0,0,0.12);
}
.entreprise-item .card {
    position: relative;
    display: -ms-flexbox;
    display: flex;
    -ms-flex-direction: column;
    flex-direction: column;
    min-width: 0;
    word-wrap: break-word;
    background-color: #fff;
    background-clip: border-box;
    border: 1px solid hsla(0, 0%, 0%, 0.125);
    border-radius: .25rem;
    .card-actions {
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    z-index: 50;
    position: absolute;
    display: -webkit-box;
    display: flex;
    -webkit-box-align: center;
    flex-direction: row-reverse;
    right:0;
    top:5px;
    height: 60px;
    width: 100px;
    -webkit-box-pack: center;
    justify-content: center;


    button {
    margin-top: 5px;
    margin-left: 5px;
    height: 32px;
    padding: 0 11px;
    font-size: 14px;
    line-height: 30px;
    color: #767676;
    fill: currentColor;
    background-color: rgba(255, 255, 255, 0.9);
    border: 1px solid transparent;
    box-shadow: 0 1px 2px rgba(0, 0, 0, 0.06);
    border: 1px solid transparent;
    border-radius: 4px;
    box-shadow: 0 1px 1px rgba(0, 0, 0, 0.04);
    -webkit-transition: all 0.1s ease-in-out;
    transition: all 0.1s ease-in-out;
    text-align: center;
    -webkit-user-select: none;
    -ms-user-select: none;
    -moz-user-select: none;
    user-select: none;
    pointer-events: auto;
    }
    }
    .overlay .mask {
    opacity: 0;
    -webkit-transition: all .4s ease-in-out;
    transition: all .4s ease-in-out;
}

.view .mask {
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    width: 100%;
    height: 100%;
    overflow: hidden;
    background-attachment: fixed;
}
.waves-effect {
    position: relative;
    overflow: hidden;
    cursor: pointer;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    -webkit-tap-highlight-color: transparent;
}
.card-footer:last-child {
    border-radius: 0 0 calc(0.25rem - 1px) calc(0.25rem - 1px);
}


.card-footer {
    padding: .75rem 1.25rem;
    background-color: rgba(0,0,0,0.03);
    border-top: 1px solid rgba(0,0,0,0.125);
    a{
        color: #6c747d;
    text-decoration: none;
    }
        a:hover{
        color: #6c747d;
    text-decoration: underline;
    }
}
.card-body {

      flex: 1 1 auto;
    min-height: 1px;
    padding: 1.25rem;
    padding-top: 1.5rem;
    padding-bottom: 1.5rem;
    border-radius: 0 !important;


    .card-text {
    font-size: .9rem;
    font-weight: 400;
    color: #747373;
    margin-bottom: 1rem;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
    
}
.card-title {
    margin-bottom: .75rem;
    float:none;
}
}


    .view.view-cascade {
    border-radius: .25rem;
        background-color: #6c757d9e;
    -webkit-box-shadow: 0 5px 11px 0 rgba(0,0,0,0.18), 0 4px 15px 0 rgba(0,0,0,0.15);
    box-shadow: 0 5px 11px 0 rgba(0,0,0,0.18), 0 4px 15px 0 rgba(0,0,0,0.15);
}

.view {
    position: relative;
    overflow: hidden;
    cursor: default;
    z-index: 10;

    img, video {
    position: relative;
    display: block;
}

.card-img, .card-img-top {
    border-top-left-radius: calc(0.25rem - 1px);
    border-top-right-radius: calc(0.25rem - 1px);
}

.rgba-white-slight, .rgba-white-slight:after {
    background-color: rgba(255,255,255,0.1);
}
}
}
.card-text span::before
{
        content: "/";
}
.card-text span:first-child::before
{
        content: "";
}
//xxxxxxxxxxxxxxxxxxxxxxxxxxx
.rgba-white-slight, .rgba-white-slight:after {
    background-color: rgba(255, 57, 57, 0.1);
}
.entreprise-item .card .view {
    min-height: 195.94px;
}
.nationalite-flag
{
position: absolute !important;
    width: 29px !important;
    height: 20px;
    z-index:20;
    border-radius: 3px !important;
    left: 10px;
    top: 11px;
}
.card-img-top
{
    .logo-img
    {
      margin-bottom:20px;
    }
    
}
.entreprise-item .card .card-actions {
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    z-index: 50;
    position: absolute;
    display: -webkit-box;
    display: flex;
    -webkit-box-align: center;
    flex-direction: column;
    right: 0;
    top: 5px;
    height: 100px;
    width: 50px;
    margin-right: 8px;
    -webkit-box-pack: center;
    justify-content: center;
}
</style>